#
# criterion.py - Database model for release criteria
#
# Copyright 2012, Red Hat, Inc
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Authors:
#   Tim Flink <tflink@redhat.com>

from blockerbugs import db
import datetime


class Criterion(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    date_created = db.Column(db.DateTime, unique=False)
    criterion = db.Column(db.String(4096), unique=False)
    current = db.Column(db.Boolean)
    milestone_id = db.Column(db.Integer, db.ForeignKey('milestone.id'))
    number = db.Column(db.Integer, unique=False)

    def __init__(self, criterion, milestone, number,
                 date_created=datetime.datetime.utcnow(), current=True):
        self.criterion = criterion
        self.milestone = milestone
        self.number = number
        self.current = current
        self.date_created = date_created

    def __repr__(self):
        return "<criterion: F%d-%s num %d>" % (self.release.number, self.release.name, self.number)
